package net.t2code.t2codelib.VELOCITY.api.update;


import com.velocitypowered.api.command.CommandSource;
import com.velocitypowered.api.plugin.PluginContainer;
import com.velocitypowered.api.proxy.ProxyServer;
import net.t2code.t2codelib.T2CupdateObject;
import net.t2code.t2codelib.T2CupdateWebData;
import net.t2code.t2codelib.UpdateType;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CVsend;
import net.t2code.t2codelib.VELOCITY.system.config.T2CVlibConfig;
import org.slf4j.Logger;

import java.time.Duration;
import java.util.HashMap;

public class T2CVupdateAPI {
    public static HashMap<String, T2CupdateObject> bungeePluginVersins = new HashMap<>();

    public static void sendUpdateMsg(Logger logger, String prefix, String discord, T2CupdateWebData webData, PluginContainer plugin) {
        String publicVersion = webData.getVersion();
        String pluginVersion = plugin.getDescription().getVersion().orElse("unknown");
        String value;
        if (webData.isPreRelease()) {
            value = UpdateType.PRERELEASE_.text;
            if (publicVersion.toLowerCase().contains("dev")) {
                value = UpdateType.DEVELOPMENT_.text;
            }
            if (publicVersion.toLowerCase().contains("beta")) {
                value = UpdateType.BETA_.text;
            }
            if (publicVersion.toLowerCase().contains("snapshot")) {
                value = UpdateType.SNAPSHOT_.text;
            }
        } else value = UpdateType.STABLE_.text;
        T2CVsend.console(logger, "╔══════════════" + prefix + "══════════════");
        T2CVsend.console(logger, "║ A new [value] version was found!".replace("[value]", value));
        T2CVsend.console(logger, "║ Your version: " + pluginVersion + " - Current version: " + webData.getVersion());
        T2CVsend.console(logger, "║ You can download it here: " + webData.getUpdateUrl());
        T2CVsend.console(logger, "║ You can find more information on Discord: " + discord);
        T2CVsend.console(logger,  "╚══════════════" + prefix + "══════════════");
    }

    private static Boolean noUpdate = true;
    private static String pluginVersion;

    public static void onUpdateCheckTimer(Logger logger, PluginContainer plugin, ProxyServer server, String prefix, String discord, Integer spigotID, String url) {
        if ((int) T2CVlibConfig.VALUES.updateTimer.getValue() < 1) {
            T2CVlibConfig.VALUES.updateTimer.setValue(1);
        }

        server.getScheduler().buildTask(plugin, () -> {
                (new T2CVupdateCheckerGit(plugin,logger)).getVersion((webData) -> {
                    pluginVersion = plugin.getDescription().getVersion().toString();
                    T2CupdateObject update = new T2CupdateObject(
                            plugin.getDescription().getName().toString(),
                            plugin.getDescription().getVersion().toString(),
                            webData,
                            false,
                            !plugin.getDescription().getVersion().equals(webData.getVersion()),
                            true
                    );
                    bungeePluginVersins.put(plugin.getDescription().getName().toString(), update);
                    if (!pluginVersion.replace("_Velocity", "").equalsIgnoreCase(webData.getVersion())) {
                        sendUpdateMsg(logger,prefix, discord, webData, plugin);
                        noUpdate = true;
                    } else {
                        if (noUpdate) {
                            T2CVsend.console(logger, " No update found.");
                            noUpdate = false;
                        }
                    }
                }, pluginVersion, spigotID, url);

        }).repeat(Duration.ofMinutes((int) T2CVlibConfig.VALUES.updateTimer.getValue())).schedule();
    }
}
