package net.t2code.t2codelib.VELOCITY.system.config;

import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.T2CconfigItem;
import net.t2code.t2codelib.Util;
import net.t2code.t2codelib.VELOCITY.api.messages.T2CVsend;
import net.t2code.t2codelib.VELOCITY.api.yml.T2CVconfigWriter;
import org.slf4j.Logger;

import java.io.File;
import java.io.IOException;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class T2CVlibConfig {

    public enum VALUES implements T2CconfigItem {
        updateTimer("updateCheck.timerInMin", 60, "In this option you can set the time interval in minutes in which updates should be checked."),
        seePreReleaseUpdates("updateCheck.seePreReleaseUpdates", true, "In this option you can set whether you want to receive and display beta and snapshot versions in the update check."),

        debug("plugin.debug.debugModus", false, "The debug mode sends more detailed debug information to the console."),

        apiCommandGUIEnable("api.commandGUI.enable", false, "With this option you activate the api interface for the T2C-CommandGUI plugin."),
        apiAutoResponse("api.autoResponse.enable", false, "With this option you activate the api interface for the T2C-AutoResponse plugin."),
        apiOpSecurity("api.opSecurity.enable", false, "With this option you activate the api interface for the T2C-OPSecurity plugin."),
        ;


        private final String path;
        private Object value;
        private final List<String> comments;

        VALUES(String path, Object value, String... comments) {
            this.path = path;
            this.value = value;
            this.comments = new ArrayList<>(Arrays.asList(comments));
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public List<String> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(Path dataDirectory, Logger logger) throws IOException {
        long long_ = System.currentTimeMillis();
        T2CVconfigWriter.createConfig(logger, new File(dataDirectory.getParent() + "/T2CodeLib", "config.yml"), VALUES.values(), Util.getConfigLogo());
        T2CVsend.info(logger, "║ The config.yml were successfully created / updated." + " - " + (System.currentTimeMillis() - long_) + "ms");
    }
}
